Leetcode2216. 美化数组的最少删除数

Every day a Leetcode

题目来源:2216. 美化数组的最少删除数

解法1:模拟

使用变量 count 代表已删除的元素个数,由于每次删除元素,剩余元素都会往前移动,因此当前下标为 i - count。

遍历一次数组 nums,若当前下标为偶数,且与下一位置元素相同,那么当前元素需被删除,令 count 自增。

最终数组长度为 n - count,若长度为奇数,需要再额外删除结尾元素(count 再加一),否则 count 即为答案。

代码:

c 复制代码
/*
 * @lc app=leetcode.cn id=2216 lang=cpp
 *
 * [2216] 美化数组的最少删除数
 */

// @lc code=start
class Solution
{
public:
    int minDeletion(vector<int> &nums)
    {
        int n = nums.size();
        int count = 0;
        for (int i = 0; i < n - 1; i++)
            if ((i - count) % 2 == 0 && nums[i] == nums[i + 1])
                count++;
        return (n - count) % 2 == 0 ? count : count + 1;
    }
};
// @lc code=end

结果:

复杂度分析:

时间复杂度:O(n),其中 n 是数组 nums 的长度。

空间复杂度:O(1)。

解法2:贪心

根据题目描述,我们知道,一个美丽数组有偶数个元素,且如果我们把这个数组中每相邻两个元素划分为一组,那么每一组中的两个元素都不相等。这意味着,组内的元素不能重复,但组与组之间的元素可以重复。

因此,我们考虑从左到右遍历数组,只要遇到相邻两个元素相等,我们就将其中的一个元素删除,即删除数加一;否则,我们可以保留这两个元素。

最后,我们判断删除后的数组长度是否为偶数,如果不是,则说明我们需要再删除一个元素,使得最终的数组长度为偶数。

代码:

c 复制代码
class Solution
{
public:
    int minDeletion(vector<int> &nums)
    {
        int n = nums.size();
        int ans = 0;
        for (int i = 0; i < n - 1; i++)
        {
            if (nums[i] == nums[i + 1])
                ans++;
            else
                i++;
        }
        ans += (n - ans) % 2;
        return ans;
    }
};

结果:

复杂度分析:

时间复杂度:O(n),其中 n 是数组 nums 的长度。

空间复杂度:O(1)。

相关推荐
zyl76512 小时前
FlashAttention 详解:从 GPU 硬件、普通 Attention 到分块计算与 Online Softmax
算法
爱读书的小胖15 小时前
LeetCode 122:买卖股票的最佳时机 II(C)解题分析
算法
结局无敌15 小时前
React Native for OpenHarmony 实战:三方库 react-native-modal-dialog 的鸿蒙化适配指南
深度学习·算法·react native·react.js·harmonyos
OPEN-F16 小时前
ROS2系列教程:上位机建图与导航(原理综合)
算法·机器人
weixin_3077791316 小时前
C++代码实现MATLAB中的fitrtree函数功能
开发语言·c++·算法·matlab
AI wins16 小时前
c++新增頭文件
c++
Shadow(⊙o⊙)16 小时前
仿muduo实现高并发服务器——事件就绪管理Channel.hpp
服务器·c++
tomwang032216 小时前
路径优化建模、优化算法分类及工程化小结
算法·数学建模·分类
小羊没烦恼!16 小时前
Ajax与JSON的一些总结
android·java·前端·数据库·mysql·算法·okhttp
by2099916 小时前
哈希表——快速找到数据:冲突、删除与扩容的实现
数据结构·c++·哈希算法·散列表